<?php
/*
  $Id: order_check.php, v 3.0 15/12/2015 figue Exp $
  Part of contribution OrdersCheck. 
  This script is not included in the original version of osCommerce

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  $order_check = 'True'; // True or False
  $send_email = 'True'; // True or False
  $payment_filter = 'False'; // True or False
  
//  ------------------------------------------------------------------------------------------
//  data insert functions below.
  if (MODULE_ORDER_TOTAL_INSTALLED) {
   $order_totals = $order_total_modules->process();
   //$output_orders_total =  $order_total_modules->output();
  }

 // discrimina segun forma de pago.
 if ($payment_filter == 'True') {
  // forma de pago seleccionada	
  $pay_met = $order->info['payment_method'];
	
  // formas de pago posibles. Aade o descomenta las formas de pago que necesites incluir.
  $payment_list = '';
  $payment_list .= MODULE_PAYMENT_CAJARURAL_TEXT_TITLE;
  $payment_list .= MODULE_PAYMENT_REDSYS_TEXT_TITLE;
  $payment_list .= MODULE_PAYMENT_TRANSFER_TEXT_TITLE;
  $payment_list .= MODULE_PAYMENT_COD_TEXT_TITLE;
  $payment_list .= MODULE_PAYMENT_PAYPAL_STANDARD_TEXT_PUBLIC_TITLE;

  if (strpos($payment_list, $pay_met) === false) $order_check = 'False';
 } // end if ($payment_filter == 'True')
 // fin discrimina segun forma de pago.

// continua la carga del script si este esta activado.
 if ($order_check == 'True') {
 
////////// 
    $orders_max_query = tep_db_query("select max(orders_id) as max_id from " . TABLE_ORDERS . "");
    $orders_max = tep_db_fetch_array($orders_max_query);
    $next_orders_id = $orders_max['max_id']+1;
    $session_id = tep_session_id();
 
 	$holding_orders_query = tep_db_query("select holding_orders_id from " . TABLE_HOLDING_ORDERS_TO_ORDERS . " where session_id = '" . $session_id . "'");
    $holding_orders = tep_db_fetch_array($holding_orders_query);
    if (tep_db_num_rows($holding_orders_query)) {
	  $holding_orders_id = $holding_orders['holding_orders_id'];
    // borro las entradas anteriores
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS . " where orders_id = '" . (int)$holding_orders_id . "'");
    tep_db_query("delete from " . TABLE_HOLDING_ORDERS_TO_ORDERS . " where session_id = '" . tep_db_input($session_id) . "'");
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS_TOTAL . " where orders_id = '" . (int)$holding_orders_id . "'");
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS_STATUS_HISTORY . " where orders_id = '" . (int)$holding_orders_id . "'");
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS_PRODUCTS . " where orders_id = '" . (int)$holding_orders_id . "'");
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS_PRODUCTS_ATTRIBUTES . " where orders_id = '" . (int)$holding_orders_id . "'");
	tep_db_query("delete from " . TABLE_HOLDING_ORDERS_PRODUCTS_DOWNLOAD . " where orders_id = '" . (int)$holding_orders_id . "'");
	}
////////

//  ------------------------------------------------------------------------------------------
    $sql_data_array = array(
                            'customers_id' => $customer_id,
                          	'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                          	'customers_company' => $order->customer['company'],
                          	'customers_street_address' => $order->customer['street_address'],
                          	'customers_suburb' => $order->customer['suburb'],
                          	'customers_city' => $order->customer['city'],
                          	'customers_postcode' => $order->customer['postcode'],
                          	'customers_state' => $order->customer['state'],
                          	'customers_country' => $order->customer['country']['title'],
                          	'customers_telephone' => $order->customer['telephone'],
                          	'customers_email_address' => $order->customer['email_address'],
                          	'customers_address_format_id' => $order->customer['format_id'],
                          
                          	'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
                          	'delivery_company' => $order->delivery['company'],
                          	'delivery_street_address' => $order->delivery['street_address'],
                          	'delivery_suburb' => $order->delivery['suburb'],
                          	'delivery_city' => $order->delivery['city'],
                          	'delivery_postcode' => $order->delivery['postcode'],
                          	'delivery_state' => $order->delivery['state'],
                          	'delivery_country' => $order->delivery['country']['title'],
                          	'delivery_address_format_id' => $order->delivery['format_id'],
                          
                          	'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
                          	'billing_company' => $order->billing['company'],
				          //NIF start - figue
				      //    	'billing_nif' => $order->billing['nif'],
				          //NIF end - figue
                          	'billing_street_address' => $order->billing['street_address'],
                          	'billing_suburb' => $order->billing['suburb'],
                          	'billing_city' => $order->billing['city'],
                          	'billing_postcode' => $order->billing['postcode'],
                          	'billing_state' => $order->billing['state'],
                          	'billing_country' => $order->billing['country']['title'],
                          	'billing_address_format_id' => $order->billing['format_id'],
                          
                          	'payment_method' => $order->info['payment_method'],
                          	'cc_type' => $order->info['cc_type'],
                          	'cc_owner' => $order->info['cc_owner'],
                          	'cc_number' => $order->info['cc_number'],
                          	'cc_expires' => $order->info['cc_expires'],
                          	'date_purchased' => 'now()',
                          	
                          	'orders_status' => $order->info['order_status'],
                          	'currency' => $order->info['currency'],
                          	'currency_value' => $order->info['currency_value']
                            );
//save orders data in pre registring table
    tep_db_perform(TABLE_HOLDING_ORDERS, $sql_data_array);
    $insert_id = tep_db_insert_id();

//  ------------------------------------------------------------------------------------------
//  Holding Orders to Orders
    $sql_data_array = array(
                          	'orders_id' => $next_orders_id,
                          	'holding_orders_id' => $insert_id,
                          	'session_id' => tep_db_input($session_id),
                          	'date_purchased' => 'now()'
                          );
    tep_db_perform(TABLE_HOLDING_ORDERS_TO_ORDERS, $sql_data_array);

//  ------------------------------------------------------------------------------------------
//  Orders's Total
    for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
    	$sql_data_array = array(
                          		'orders_id' => $insert_id,
                          		'title' => $order_totals[$i]['title'],
                          		'text' => $order_totals[$i]['text'],
                          		'value' => $order_totals[$i]['value'],
                          		'class' => $order_totals[$i]['code'],
                          		'sort_order' => $order_totals[$i]['sort_order']
                          	);
    	tep_db_perform(TABLE_HOLDING_ORDERS_TOTAL, $sql_data_array);
    }

//  ------------------------------------------------------------------------------------------
//  Time for the Order histroy
    $sql_data_array = array(
                          	'orders_id' => $insert_id,
                          	'orders_status_id' => $order->info['order_status'],
                          	'date_added' => 'now()',
                          	'customer_notified' => $customer_notification,
                          	'comments' => $order->info['comments']
                          );
    tep_db_perform(TABLE_HOLDING_ORDERS_STATUS_HISTORY, $sql_data_array);

// initializing variables
        $products_ordered = '';
        $subtotal = 0;
        $total_tax = 0;

  for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
//  ------------------------------------------------------------------------------------------
//  Now time for a loopy through the products
	$sql_data_array = array(
                      		'orders_id' => $insert_id,
                      		'products_id' => tep_get_prid($order->products[$i]['id']),
                      		'products_model' => $order->products[$i]['model'],
                      		'products_name' => $order->products[$i]['name'],
                      		'products_price' => $order->products[$i]['price'],
                      		'final_price' => $order->products[$i]['final_price'],
                      		'products_tax' => $order->products[$i]['tax'],
                      		'products_quantity' => $order->products[$i]['qty']
                      	);
	tep_db_perform(TABLE_HOLDING_ORDERS_PRODUCTS, $sql_data_array);
	$order_products_id = tep_db_insert_id();

//------insert customer choosen option to order--------
	$attributes_exist = '0';
	$products_ordered_attributes = '';
	 if (isset($order->products[$i]['attributes'])) {
		$attributes_exist = '1';
		for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
			if (DOWNLOAD_ENABLED == 'true') {
				$attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename 
                                    from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad on pa.products_attributes_id=pad.products_attributes_id
                                    where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
			} else {
				$attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix 
                                    from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa 
                                    where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
			}
			$attributes_values = tep_db_fetch_array($attributes);

//  ------------------------------------------------------------------------------------------
// The product attributes
			$sql_data_array = array(
                      				'orders_id' => $insert_id,
                      				'orders_products_id' => $order_products_id,
                      				'products_options' => $attributes_values['products_options_name'],
                      				'products_options_values' => $attributes_values['products_options_values_name'],
                      				'options_values_price' => $attributes_values['options_values_price'],
                      				'price_prefix' => $attributes_values['price_prefix']
                      			);
			tep_db_perform(TABLE_HOLDING_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

			if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
//  ------------------------------------------------------------------------------------------
// Do we have a downloadable product?
				$sql_data_array = array(
                      					'orders_id' => $insert_id,
                      					'orders_products_id' => $order_products_id,
                      					'orders_products_filename' => $attributes_values['products_attributes_filename'],
                      					'download_maxdays' => $attributes_values['products_attributes_maxdays'],
                      					'download_count' => $attributes_values['products_attributes_maxcount']
                      				);
				tep_db_perform(TABLE_HOLDING_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
			}
//			$products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name'];
		}
	 }
//  ------------------------------------------------------------------------------------------
  }

 // envio un email al administrador para informar que hay un posible pedido.
 if ($send_email == 'True') {
  $email_order = STORE_NAME . "\n" . 
				 EMAIL_TEXT_SUBJECT . "\n" .
                 EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
                 EMAIL_SEPARATOR . "\n\n";
				 
    $email_order .= EMAIL_TEXT_CUSTOMER . ' (Id: ' . $customer_id . ')' . "\n" .
                 tep_address_format($order->billing['format_id'], $order->billing, 1, ' ', "\n") . "\n\n";
  
    if (is_object($$payment)) {
      $payment_class = $$payment;
      $email_order .= EMAIL_TEXT_PAYMENT_METHOD . $order->info['payment_method'] . "\n";
    }
	
    $email_order .= EMAIL_TEXT_ORDER_TOTAL . $currencies->format($order->info['total'], true, $order->info['currency'], $order->info['currency_value']) . "\n\n";
	$email_subject = EMAIL_TEXT_SUBJECT;
    $email_text = '<font face="Arial"><span style="font-size:11.0pt;">' . $email_order . '</span></font>';

  tep_mail(' ', STORE_OWNER_EMAIL_ADDRESS, $email_subject, $email_text, $order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address']);
 }
 // fin envio un email al administrador para informar que hay un posible pedido.

} // end if ($order_check == 'True')
// fin continua la carga del script si este esta activado.

?>
